#include <stdio.h>
#include <assert.h>
#include <yepLibrary.h>

int main(int argc, char **argv) {
	enum YepStatus status;
	Yep32u coresCount, L1I, L1D, L2, L3;

	status = yepLibrary_Init();
	assert(status == YepStatusOk);

	status = yepLibrary_GetLogicalCoresCount(&coresCount);
	assert(status == YepStatusOk);
	printf("Logical cores: %u\n", (unsigned)(coresCount));
	
	status = yepLibrary_GetCpuInstructionCacheSize(1, &L1I);
	assert(status == YepStatusOk);
	printf("L1I: %u\n", (unsigned)(L1I));
	
	status = yepLibrary_GetCpuDataCacheSize(1, &L1D);
	assert(status == YepStatusOk);
	printf("L1D: %u\n", (unsigned)(L1D));
	
	status = yepLibrary_GetCpuDataCacheSize(2, &L2);
	assert(status == YepStatusOk);
	printf("L2: %u\n", (unsigned)(L2));
	
	status = yepLibrary_GetCpuDataCacheSize(3, &L3);
	assert(status == YepStatusOk);
	printf("L3: %u\n", (unsigned)(L3));
	
	status = yepLibrary_Release();
	assert(status == YepStatusOk);
	return 0;
}
